unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, RXSpin, Mask, ToolEdit, StrUtils;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Left: TButton;
    Right: TButton;
    FilenameEdit1: TFilenameEdit;
    Next: TButton;
    MaxHSize: TRxSpinEdit;
    MaxVSize: TRxSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    HSize: TRxSpinEdit;
    VSize: TRxSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Orientation: TRadioGroup;
    Horizontal: TRadioGroup;
    Vertical: TRadioGroup;
    Label5: TLabel;
    OffsetLabel: TLabel;
    Label6: TLabel;
    Delay: TRxSpinEdit;
    StartButton: TButton;
    NextParams: TButton;
    Label7: TLabel;
    ReadedBytesLabel: TLabel;
    OpenFile: TButton;
    procedure StartButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure NextParamsClick(Sender: TObject);
    procedure LeftClick(Sender: TObject);
    procedure RightClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure OpenFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Scanning;
    procedure ShowSlice;
    procedure NextParameters;
    procedure ReadSlice;
  end;
procedure BitmapToPaintBox(BMP: TBitmap; PB: TPaintBox);

var
  Form1: TForm1;
  AutoScanning: Boolean=False;
  Offset: Longint=0;
  ReadedBytes: Longint;
  BMP: TBitmap;
  F: File of Byte;
  Buffer: array[0..32767] of byte;

implementation

{$R *.DFM}

procedure BitmapToPaintBox(BMP: TBitmap; PB: TPaintBox);
begin
  try
  if (PB.Width=BMP.Width) and (PB.Height=BMP.Height)
    then PB.Canvas.Draw(0,0,BMP)
    else PB.Canvas.StretchDraw(Rect(0,0,PB.Width,PB.Height),BMP);
  except end;
end;

procedure TForm1.StartButtonClick(Sender: TObject);
begin
  AutoScanning:=not AutoScanning;
  if AutoScanning then begin
    StartButton.Caption:='Stop Auto Scanning Params';
    Scanning; end
  else StartButton.Caption:='Start Auto Scanning Params';
end;

procedure TForm1.Scanning;
var T,D: Longint;
begin
  D:=Round(Delay.Value);
  while AutoScanning do begin
    NextParameters;
    T:=GetTickCount;
    {while GetTickCount<=T+D do} Application.ProcessMessages; end;
end;

procedure TForm1.NextParameters;
begin
  Orientation.ItemIndex:=1-Orientation.ItemIndex;
  if (Orientation.ItemIndex=0) and (Horizontal.ItemIndex=0) and
     (Vertical.ItemIndex=0) then begin
    if VSize.Value<MaxVSize.Value then VSize.Value:=VSize.Value+1
    else begin
      VSize.Value:=1;
      if HSize.Value<MaxHSize.Value then HSize.Value:=HSize.Value+1 else HSize.Value:=1; end;
    if (HSize.Value=1) and (VSize.Value=1) then Right.OnClick(nil); end;
  ShowSlice;
end;

procedure TForm1.ShowSlice;
var Dest: Pointer; H,V,HV,NS,hh,vv,x,y,Orient: Word;
begin
  Dest:=BMP.ScanLine[BMP.Height-1];
  H:=Round(HSize.Value);
  V:=Round(VSize.Value);
  HV:=H*V;
  Orient:=Orientation.ItemIndex;
  asm
    pusha
    lea   esi,Buffer
    xor   ecx,ecx
    @m1:  mov   ax,cx           // L (Offset in File-Buffer)
          xor   dx,dx
          mov   bx,HV
          div   bx
          mov   NS,ax           // L div (H*V)
          mov   di,dx           // L mod (H*V)
          cmp   Orient,0
          jne   @m2
          mov   ax,cx           // L
          xor   dx,dx
          mov   bx,H
          div   bx
          mov   hh,dx           // L mod H
          mov   ax,di           // L mod (H*V)
          xor   dx,dx
          mov   bx,H
          div   bx
          mov   vv,ax           // (L mod (H*V)) div H
          jmp   @m3
    @m2:  mov   ax,di           // L mod (H*V)
          xor   dx,dx
          mov   bx,V
          div   bx
          mov   hh,ax           // (L mod (H*V)) div V
          mov   ax,cx           // L
          xor   dx,dx
          mov   bx,V
          div   bx
          mov   vv,dx           // L mod V
    @m3:  mov   ax,NS
          mov   dx,V
          mul   dx
          add   ax,vv           // NS*V + vv
          xor   dx,dx
          mov   bx,512
          div   bx
          mov   y,dx            // (NS*V + vv) mod 512
          mov   dx,H
          mul   dx
          add   ax,hh
          mov   x,ax            // H*((NS*V + vv) div 512) + hh
          mov   ax,y
          mov   dx,64
          mul   dx
          add   ax,x            // 64*y + x
          and   eax,0ffffh
          mov   edi,eax
          lodsb
          add   edi,Dest
          mov   byte ptr [edi],al
          inc   ecx
          cmp   ecx,8000h
          jl    @m1
    popa
  end;
  BitmapToPaintBox(BMP,PaintBox1);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BMP:=TBitmap.Create;
  BMP.Width:=512; BMP.Height:=512; BMP.PixelFormat:=pf1bit;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BMP.Free;
  {$I-}
  CloseFile(F);
  {$I+}
end;

procedure TForm1.NextParamsClick(Sender: TObject);
begin
  NextParameters;
end;

procedure TForm1.ReadSlice;
begin
  OffsetLabel.Caption:='$'+Dec2Hex(Offset,8);
  {$I-}
  Seek(F,Offset);
  BlockRead(F, Buffer, SizeOf(Buffer), ReadedBytes);
  {$I+}
  ReadedBytesLabel.Caption:='$'+Dec2Hex(ReadedBytes,8);
  ShowSlice;
end;

procedure TForm1.LeftClick(Sender: TObject);
begin
  if Offset>0 then begin
    Offset:=Offset-SizeOf(Buffer);
    ReadSlice; end;
end;

procedure TForm1.RightClick(Sender: TObject);
begin
  if not EOF(F) then begin
    Offset:=Offset+SizeOf(Buffer);
    ReadSlice; end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  BitmapToPaintBox(BMP,PaintBox1);
end;

procedure TForm1.OpenFileClick(Sender: TObject);
begin
  {$I-}
  AssignFile(F,FileNameEdit1.FileName{'G:\Work\FontFileViewer\DEMO.EXE'});
  FileMode:=0;
  Reset(F);
  {$I+}
  if IOResult<>0
    then begin ShowMessage('File Open Error !'); FileNameEdit1.SetFocus; end
    else ReadSlice;
end;

end.
